package gabriel.proyecto.Forms;

import gabriel.proyecto.ImageAdapter;
import gabriel.proyecto.R;
import gabriel.proyecto.XmlProyecto;

import java.io.File;
import java.io.IOException;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Gallery;
import android.widget.ImageView;
import android.widget.Toast;

public class FormCrearProyecto extends Activity {

	// FORM tras crear un nuevo proyecto
	// Se elige la silueta y el nombre del proyecto mas boton de guardar
	/**
	 * @uml.property  name="xmlArchivo"
	 */
	File XmlArchivo;
	/**
	 * @uml.property  name="directorio"
	 */
	private File Directorio;
	/**
	 * @uml.property  name="imagenSeleccionada"
	 */
	 String imagenSeleccionada;
	/**
	 * @uml.property  name="g"
	 * @uml.associationEnd  
	 */
	Gallery g;

	@Override
	public void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		imagenSeleccionada = null;
		// Creamos la galeria
		setContentView(R.layout.newform);

		g = (Gallery) findViewById(R.id.gallery1);

		g.setAdapter(new ImageAdapter(FormCrearProyecto.this));

		g.setOnItemClickListener(new OnItemClickListener() {

			public void onItemClick(@SuppressWarnings("rawtypes") AdapterView parent, View v, int position,
					long id) {
				String foto = "sample_" + (position + 1);

				ImageView i = (ImageView) findViewById(R.id.imagenCoche);

				int res_imagen = FormCrearProyecto.this.getResources()
						.getIdentifier("drawable/" + foto, null,
								FormCrearProyecto.this.getPackageName());

				// Se muestra en grande la imagen de la galeria
				i.setImageResource(res_imagen);
				// Guardo en una variable el string de la imagen para pasarselo
				// a futuros Forms
				imagenSeleccionada = foto;

			}
		});

		// Boton guardar
		Button guardar = (Button) findViewById(R.id.buttonGuardar);

		guardar.setOnClickListener(new View.OnClickListener() {

			// Al pulsar click guardamos el proyecto
			public void onClick(View v) {

				EditText edit = (EditText) findViewById(R.id.editTextNombre);
				String nombre = edit.getText().toString();


				if ((nombre.equals(null)) || (nombre.equals(""))) {
					Toast t = Toast.makeText(FormCrearProyecto.this,
							"El campo nombre no puede estar vacio",
							Toast.LENGTH_SHORT);
					t.show();

					return;
				}

				if (imagenSeleccionada == null) {
					Toast t = Toast.makeText(FormCrearProyecto.this,
							"Debe elegir una silueta", Toast.LENGTH_SHORT);
					t.show();

					return;
				}

				// se crea una carpeta para el proyecto
				int creado = crearCarpetaProyecto(nombre);

				if (creado == 1) {
					// Se ha creado el proyecto, se pasa a pantalla
					// principal, pasandole
					// a la nueva actividad el nombre del proyecto y la
					// silueta escogida

					try {
						XmlProyecto xmlP = new XmlProyecto(XmlArchivo);
						xmlP.escribirProyecto(nombre, imagenSeleccionada);

						Intent intent = new Intent(FormCrearProyecto.this,
								FormProyecto.class);
						 intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
						intent.putExtra("Nombre", xmlP.getNombre());
						intent.putExtra("Silueta", xmlP.getSilueta());
						intent.putExtra("Directorio", Directorio.toString());
						startActivity(intent);
						finish();
					} catch (Exception ex) {
						Toast.makeText(
								FormCrearProyecto.this,
								"Error escribiendo Xml en el proyecto: "
										+ ex.getMessage(), Toast.LENGTH_LONG)
								.show();
						ex.printStackTrace();
					}

				}

				else {
					//No se ha creado, 0 existe otro, -1 error
					
					if (creado == 0) {
						Toast.makeText(FormCrearProyecto.this,
								"El nombre de proyecto ya existe",
								Toast.LENGTH_SHORT).show();
					} else {
						Toast.makeText(FormCrearProyecto.this,
								"Error al crear el proyecto",
								Toast.LENGTH_SHORT).show();
					}

				}
			}

		});

	}

	private int crearCarpetaProyecto(String nombre) {

		String nombreformateado=formatear(nombre);
		Directorio = Environment.getExternalStorageDirectory();
		String s = Directorio.toString() + "/";
		File carpeta = new File(s + "CarMedia/" + nombreformateado);
		XmlArchivo = new File(s + "CarMedia/" + nombreformateado + "/" + nombreformateado + ".xml");
		

		if (carpeta.exists()) {
			return 0;
		}
		boolean creada = carpeta.mkdir();

		if (creada) {
			try {
				XmlArchivo.createNewFile();

			} catch (IOException e) {
				return -1;
			}

			Directorio = carpeta;
			return 1;
		} else
			return -1;

	}

	private String formatear(String nom){
		String[] cadenas=nom.split(" ");
		String nombreformateado;
		nombreformateado=cadenas[0];
		
		for (int i=1;i<cadenas.length;i++){
			nombreformateado=nombreformateado+"+"+cadenas[i];
			
			
		}
		return nombreformateado;
	}
}
