package gabriel.proyecto.Forms;


import gabriel.proyecto.R;
import gabriel.proyecto.Titular;
import gabriel.proyecto.XmlProyecto;

import java.io.File;
import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;



public class FormInicio extends Activity {
    /**
	 * Called when the activity is first created.
	 * @uml.property  name="proyectos"
	 */

	//FORM DE INICIO, llama al MAIN.XML
	//Elige entre crear un proyecto o abrir

	ArrayList<XmlProyecto> proyectos;
	/**
	 * @uml.property  name="directorio"
	 */
	private File Directorio;
	/**
	 * @uml.property  name="datos"
	 * @uml.associationEnd  multiplicity="(0 -1)"
	 */
	
	boolean listaProyectos;
	 Titular[] datos =		    
			new Titular[]{		      
			new Titular("Nuevo", "Crear un nuevo proyecto"),      
			new Titular("Abrir", "Abrir un proyecto reciente")
	 };
	 

	@Override
 
	public void onCreate(Bundle savedInstanceState) {
        
    	super.onCreate(savedInstanceState);
    	listaProyectos=false;
    	//creamos la carpeta donde guardaremos todo el proyecto si no existe
    	crearCarpeta();
    	
    	setContentView(R.layout.main);
    	IniciarMenu();
        
    }
    
   
	
	private void crearCarpeta() {
		Directorio=Environment.getExternalStorageDirectory();
       
		try {
        	
        
        	String s=Directorio.toString()+"/";
        	File carpeta=new File(s+"CarMedia");
        	Directorio=carpeta;
        	// Si no existe la creamos
        	if (!carpeta.exists()){
        		
        		boolean creada=carpeta.mkdirs();
        		if (creada){
        			
        		}
        			//{Directorio=carpeta;}
        		else{	
        		//TODO: Informar error
        			Toast.makeText(FormInicio.this, "la carpeta no se puede crear", Toast.LENGTH_SHORT).show();
        		}
        	}
        	else{
        		
        		
        	}
        	} 
		catch (Exception e) {
			//TODO: Informar error
			e.printStackTrace();
		}
		
		
	}



	private void IniciarMenu(){
		
		 AdaptadorTitulares adaptador = new AdaptadorTitulares(this);
		        
		 ListView lstOpciones = (ListView)findViewById(R.id.LstOpciones);
		 
		 lstOpciones.setOnItemClickListener(new OnItemClickListener() {
			    public void onItemClick(AdapterView<?> parent, View view,int position, long id) {
			    	if (position==0){
			    	
			    	
			    		Intent intent=new Intent(FormInicio.this,FormCrearProyecto.class);
			    		intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
			    		startActivity(intent);
			    		

			    		
			    		
			    	}else if (position==1){
			    	
			    		File[] archivos=Directorio.listFiles();
			    		
			    		proyectos=new ArrayList<XmlProyecto>();
			    		
			    	
			    		
			    		for( int i=0; i<archivos.length;i++){
			    			if (archivos[i].isDirectory()){
			    				
			    				String nombre=archivos[i].getName();
			    				//Si es una carpeta y contiene un archivo Xml del mismo nombre que la carpeta es un proyecto
			    				File archivoXml=new File(archivos[i], nombre+".xml");
			    				
			    				if (archivoXml.exists() ){
			    					XmlProyecto p=new XmlProyecto();
			    					String direccion=null;
			    					try{
			    					direccion=archivoXml.getCanonicalPath();
			    					}
			    					catch(Exception ex){
			    						
			    					}
			    					boolean formatoCorrecto=p.abrirXml(direccion);
			    					
			    					if (formatoCorrecto){
			    					proyectos.add(p);
			    					}
			    			
			    				}
			    			}	
			    		}
			    		if (proyectos.size()>0){
			    			listaProyectos=true;
			    			AdaptadorProyectos adaptador = new AdaptadorProyectos(FormInicio.this,proyectos);
			    			ListView lstProyectos = (ListView)findViewById(R.id.LstOpciones);
			    			lstProyectos.setAdapter(adaptador);
			    			
			    			lstProyectos.setOnItemClickListener(new OnItemClickListener() {
			    				 public void onItemClick(AdapterView<?> parent, View view,int position, long id) {
			    					 
			    					 
			    					 XmlProyecto xmlP=proyectos.get(position);		    			
			    					 Intent intent=new Intent(FormInicio.this,FormProyecto.class);
			    					 intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
			    					 intent.putExtra("Nombre", xmlP.getNombre());
			    			    		
			    					 intent.putExtra("Silueta",xmlP.getSilueta());
			    			    		
			    					 intent.putExtra("Directorio", Directorio.toString()+"/"+xmlP.getNombre());
			                		
			    					 startActivityForResult(intent,100);

			    				 }
			    				
			    			});
			    			
			    		}		
			    		else{
			    			Toast.makeText(FormInicio.this,"No hay proyectos guardados",Toast.LENGTH_SHORT).show();
			    			
			    		}
			    	}   	

			    }
			      
		 });
		 lstOpciones.setAdapter(adaptador);
		 
    	
    }
    
    
    @SuppressWarnings("rawtypes")
	class AdaptadorTitulares extends ArrayAdapter {
   	 
    	//Clase para mostrar los titulares de la lista de opciones (Nuevo y abrir)
        Activity context;
     
            
        @SuppressWarnings("unchecked")
		AdaptadorTitulares(Activity context) {
        
                super(context, R.layout.listitem_titular, datos);
                this.context = context;
                
        }
     
            
            public View getView(int position, View convertView, ViewGroup parent) {
	            LayoutInflater inflater = context.getLayoutInflater();
	            View item = inflater.inflate(R.layout.listitem_titular, null);
	     
	            TextView lblTitulo = (TextView)item.findViewById(R.id.LblTitulo);
	            lblTitulo.setText(datos[position].getTitulo());
	     
	            TextView lblSubtitulo = (TextView)item.findViewById(R.id.LblSubTitulo);
	            lblSubtitulo.setText(datos[position].getSubtitulo());
	     
	            return(item);
        }
    }
    
    @SuppressWarnings("rawtypes")
	class AdaptadorProyectos extends ArrayAdapter{
     	//Clase para mostrar los titulares de la lista de opciones (Nuevo y abrir)
        Activity context;
        ArrayList<XmlProyecto> proyectos;
            
        //Constructor
        @SuppressWarnings("unchecked")
		public AdaptadorProyectos(Activity context,ArrayList<XmlProyecto> Proyectos) {
       
        		super(context, R.layout.listitem_titular, Proyectos);
                this.context = context;
                this.proyectos=Proyectos;
                
        }
        public View getView(int position, View convertView, ViewGroup parent) {
        	
        

        	
        	LayoutInflater inflater = context.getLayoutInflater();
        	View item = inflater.inflate(R.layout.listitem_titular, null); 
	      
        	TextView lblTitulo = (TextView)item.findViewById(R.id.LblTitulo);  
	        lblTitulo.setText(proyectos.get(position).getNombre());
	 	           
	        TextView lblSubtitulo = (TextView)item.findViewById(R.id.LblSubTitulo);
	        lblSubtitulo.setText(proyectos.get(position).getFecha());
	 	     
	        return(item);
   
        	  
        }    		
        
    }

   @Override
   protected void onActivityResult(int requestCode, int resultCode, Intent data) {
	
	   super.onActivityResult(requestCode, resultCode, data);
	   if (resultCode==1000){
		   Toast t=Toast.makeText(FormInicio.this, "Error abriendo proyecto", Toast.LENGTH_LONG);
		   t.show();
	   }else{
		 if (requestCode==100){
		   
			Intent intent=new Intent(FormInicio.this,FormInicio.class);
  		 
  	
  		 	startActivity(intent);
  		 	finish();
  		 	}
	   }
   }

   @Override
   public boolean onKeyDown(int keyCode, KeyEvent event) {
	    if (keyCode == KeyEvent.KEYCODE_BACK) {
	    	
	    	if (this.listaProyectos){
	    		
	    		 Intent intent=new Intent(FormInicio.this,FormInicio.class);
	    		 intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
	    	
	    		 startActivity(intent);
	    		 finish();
	    		 return true;
	    	}
	    	else{
	    		
	    		
	    	}
	    	
	    	
	    }
	   
	    return super.onKeyDown(keyCode, event);
	 }
	    
	    

}


