package gabriel.proyecto.Forms;

import gabriel.proyecto.MyLocationListener;
import gabriel.proyecto.R;
import gabriel.proyecto.XmlProyecto;
import gabriel.proyecto.imagenes.DrawCanvasCircle;
import gabriel.proyecto.imagenes.FotoDibujo;
import gabriel.proyecto.imagenes.Punto;
import gabriel.proyecto.imagenes.Semaforo;

import java.io.File;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Locale;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.DatePickerDialog.OnDateSetListener;
import android.app.TimePickerDialog;
import android.app.TimePickerDialog.OnTimeSetListener;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.database.Cursor;
import android.graphics.BitmapFactory;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.SystemClock;
import android.provider.MediaStore;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.SoundEffectConstants;
import android.view.View;
import android.view.ViewTreeObserver;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.TimePicker;
import android.widget.Toast;

public class FormProyecto extends Activity {

	/**
	 * @uml.property name="proyecto"
	 * @uml.associationEnd
	 */
	private XmlProyecto proyecto;
	/**
	 * @uml.property name="altura"
	 */
	private int altura;
	/**
	 * @uml.property name="ancho"
	 */
	private int ancho;
	/**
	 * @uml.property name="context"
	 * @uml.associationEnd
	 */
	private Context context;

	
	/**
	 * @uml.property name="foto"
	 */
	private String foto;
	private final int INTENSO = 230;
	private final int SUAVE = 120;
	LocationManager mlocManager;
	MyLocationListener mlocListener;
	// Los puntos se obtendran de un XML
	/* Y los creados se escriben en el mismo XML */
	/**
	 * @uml.property name="puntos"
	 * @uml.associationEnd multiplicity="(0 -1)"
	 *                     elementType="gabriel.proyecto.imagenes.Punto"
	 */
	private ArrayList<Punto> puntos;

	/**
	 * @uml.property name="permitirPunto"
	 */
	private boolean permitirPunto;
	/**
	 * @uml.property name="semaforo"
	 * @uml.associationEnd
	 */
	private Semaforo semaforo;
	/**
	 * @uml.property name="imagenFondo"
	 * @uml.associationEnd
	 */
	private ImageView imagenFondo;
	/**
	 * @uml.property name="pCandidato"
	 * @uml.associationEnd
	 */
	private Punto pCandidato;

	/**
	 * @uml.property name="fotoAnadida"
	 */
	private String fotoAnadida = "";

	private static int TAKE_PICTURE = 1;
	private static int SELECT_PICTURE = 2;
	private static int GPS = 3;
	private static String[] zonas = { "piloto", "copiloto", "asiz", "asdcha",
			"ascen" };
	/**
	 * @uml.property name="directorio"
	 */
	private String Directorio;

	/**
	 * @uml.property name="handler"
	 * @uml.associationEnd
	 */
	private Handler handler;
	/**
	 * @uml.property name="nombreproy"
	 */
	private String nombreproy;

	@Override
	public void onCreate(Bundle savedInstanceState) {

		// Para que no  giren la pantalla
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

		// Para mostrar las imagenes transparentes
		getWindow().getAttributes().format = android.graphics.PixelFormat.RGBA_8888;

		Bundle bundle = getIntent().getExtras();

		// Para luego guardar el proyecto
		nombreproy = bundle.getString("Nombre");
		// nombreproy.replace(" ", "+");
		String silueta = bundle.getString("Silueta");
		Directorio = bundle.getString("Directorio");
		proyecto = new XmlProyecto();

		boolean abierto = proyecto.abrirXml(formatear(Directorio) + "/"
				+ formatear(nombreproy) + ".xml");

		if (!abierto) {

			setResult(1000);
			finish();
		}

		foto = silueta + "_div";
		
		permitirPunto = true;

		super.onCreate(savedInstanceState);
		setContentView(R.layout.form_proyecto);

		imagenFondo = (ImageView) findViewById(R.id.imageView1);

		context = FormProyecto.this;

		int res_imagen = context.getResources().getIdentifier(
				"drawable/" + foto, null, context.getPackageName());

		imagenFondo.setImageResource(res_imagen);

		puntos = CargarPuntos();

		ControlarTouch();

	}

	@Override
	public void onStart() {
		super.onStart();
		handler = new Handler();
		new Thread() {
			@Override
			public void run() {

				handler.post(new Runnable() {
					@Override
					public void run() {

						dibujarPuntos();

					}
				});

			}
		}.start();

	}

	@SuppressWarnings("unchecked")
	private ArrayList<Punto> CargarPuntos() {

		return proyecto.cargarPuntos(context);

	}

	private void ControlarTouch() {

		// Calculamos la anchura y altura

		ViewTreeObserver vto = imagenFondo.getViewTreeObserver();

		vto.addOnPreDrawListener(new ViewTreeObserver.OnPreDrawListener() {
			public boolean onPreDraw() {
				// La anchura y altura solo se puede saber una vez se ha
				// dibujado en el dispositivo Por ello lo miramos en el evento
				// onPreDraw
				altura = imagenFondo.getMeasuredHeight();
				ancho = imagenFondo.getMeasuredWidth();

				return true;
			}
		});

		imagenFondo.setOnTouchListener(new View.OnTouchListener() {
			public boolean onTouch(View v, MotionEvent evento) {

				PuntoTocado(v, evento);

				return true;
			}
		});
	}

	//Gestion cuando se toca la pantalla
	private void PuntoTocado(View v, MotionEvent evento) {

		// Creamos el punto
		Punto punto = new Punto(context, evento.getX(), evento.getY(), ancho,
				altura);

		boolean zonaCorrecta = punto.verZona(foto);

		// Si la zona es correcta
		if (zonaCorrecta) {

			if (permitirPunto) {
				String fotoZona = proyecto.getSilueta() + "_"
						+ zonas[punto.getZona()];
				int resId = context.getResources().getIdentifier(
						"drawable/" + fotoZona, null, context.getPackageName());
				imagenFondo.setImageResource(resId);

				imagenFondo.playSoundEffect(SoundEffectConstants.CLICK);
				// Vemos si existe el punto
				permitirPunto = false;
				int i;
				boolean existe = false;

				for (i = 0; i < puntos.size(); i++) {
					Punto p2 = (Punto) puntos.get(i);
					if (p2.equals(punto)) {
						existe = true;
						punto = p2;
						break;
					}

				}

				if (existe) {
					// Si existe ya lo seleccionamos, pudiendo editarlo

					dibujarPuntos();
					try {
						FrameLayout main = (FrameLayout) findViewById(R.id.formproyecto_view);
						main.removeView(punto.getVista());
					} catch (Exception x) {
					}

					dibujar(punto, INTENSO);

					// Mostramos los botones
					cambiarVisibilidadBotones(true);
					mostrarBotones(punto, 1);

					pCandidato = punto;
					pCandidato.Seleccionado = true;

				}
				if (!existe) {
					// Si no existe lo dibujo, enseo el semaforo y guardo el
					// punto

					dibujar(punto, INTENSO);

					// Muestro los botones de aadir o cancelar
					cambiarVisibilidadBotones(true);

					mostrarSemaforo(punto);
					mostrarBotones(punto, 0);

					pCandidato = punto;

				}
			}
			// Cada vez que se toca y no esta permitido el punto (se esta
			// editando) lo volvemos a dibujar por si se ha cambiado el color
			if ((pCandidato != null) && !(pCandidato.Seleccionado)) {

				actualizarColorPuntoCandidato();

			}

		} else {
			if ((pCandidato != null) && !(pCandidato.Seleccionado)) {
				actualizarColorPuntoCandidato();
			}

		}

	}

	//actualiza el color del punto candidato, por si han tocado el semaforo
	private void actualizarColorPuntoCandidato() {

		FrameLayout main = (FrameLayout) findViewById(R.id.formproyecto_view);
		main.removeView(pCandidato.getVista());
		pCandidato.setGravedad(semaforo.getColor());
		dibujar(pCandidato, INTENSO);
	}

	//muestra el semaforor
	private void mostrarSemaforo(Punto punto) {
		// Muestra el semaforo cuando se toca un punto.
		// Control de tocar semaforo
		if (punto.getY() < 0.5F) {
			semaforo = new Semaforo(context, punto.getX() * ancho + 5,
					punto.getY() * altura);
		} else {

			semaforo = new Semaforo(context, punto.getX() * ancho + 5,
					(punto.getY() * altura) - (0.2F * altura));
		}
		FrameLayout main = (FrameLayout) findViewById(R.id.formproyecto_view);

		Toast toast = Toast.makeText(context,
				"Gravedad del punto seleccionado", Toast.LENGTH_SHORT);
		toast.show();
		main.addView(semaforo);

	}

	//dibuja un punto con una intensidad alpha
	private void dibujar(Punto punto, int Alpha) {

		View v = new DrawCanvasCircle(context, punto.getX() * ancho,
				punto.getY() * altura, altura / 28, Alpha, punto.getGravedad());
		punto.setVista(v);
		FrameLayout main = (FrameLayout) findViewById(R.id.formproyecto_view);

		main.addView(v);

		// Si el punto posee una foto
		if (punto.tieneFoto()) {
			FotoDibujo fd = punto.getFotoDibujo();

			if (fd == null) {

				// Si es null dibujamos el Icono
				dibujarFotoDibujo(punto, punto.getDireccionFoto());
				fd = punto.getFotoDibujo();

			}

			// Si sta esta reducida ya, no la reduzco ms
			if (fd.Reducido()) {
				// A no ser que sea el punto recien creado o seleccionado
				if (Alpha == INTENSO) {
					punto.getFotoDibujo().ampliar();
				}
			} else {
				if (Alpha != INTENSO) {
					punto.getFotoDibujo().reducir();
				}
			}

		}

	}

	//Dibuja todos los puntos con intensidad suave
	private void dibujarPuntos() {

		FrameLayout main = (FrameLayout) findViewById(R.id.formproyecto_view);

		int i;
		for (i = 0; i < puntos.size(); i++) {
			Punto p = (Punto) puntos.get(i);
			try {
				main.removeView(p.getVista());

			}

			catch (Exception x) {

			}
			dibujar(p, SUAVE);

		}

	}
	//dibuja el icono de la foto
	private void dibujarFotoDibujo(Punto p, String fotoD) {
		// Dibuja el simbolo de foto al punto, y lo aade a este
		FrameLayout main = (FrameLayout) findViewById(R.id.formproyecto_view);
		if (p.getFotoDibujo() != null) {
			main.removeView(p.getFotoDibujo());
		}
		p.setTieneFoto(true);
		ImageView iv = new ImageView(context);
		iv.setImageBitmap(BitmapFactory.decodeFile(fotoD));

		FotoDibujo f = new FotoDibujo(context, (p.getX() * ancho) - 80,
				(p.getY() * altura) - 25, iv);

		// Si el punto ya tiene alguna foto la sustituyo

		main.addView(f);
		p.setDireccionFoto(fotoD);
		p.setFotoDibujo(f);
	}

	private void cambiarVisibilidadBotones(boolean visibilidad) {
		int aux;
		if (visibilidad) {
			aux = 0;
		} else {
			aux = 8;
		}
		Button boton = (Button) findViewById(R.id.botonAddPunto);

		boton.setVisibility(aux);
		boton.setEnabled(visibilidad);

		Button botonC = (Button) findViewById(R.id.botonCancelar);
		botonC.setVisibility(aux);
		botonC.setEnabled(visibilidad);

		Button botonFoto = (Button) findViewById(R.id.botonFoto);
		botonFoto.setVisibility(aux);
		botonFoto.setEnabled(visibilidad);

	}

	private void mostrarBotones(Punto punto, int modo) {
		// Mostrar botones de aadir y Eliminar Punto

		Button boton = (Button) findViewById(R.id.botonAddPunto);
		Button botonCancelar = (Button) findViewById(R.id.botonCancelar);
		Button botonFoto = (Button) findViewById(R.id.botonFoto);
		if (modo == 1) {

			botonFoto.setText("Editar Punto");
			boton.setText("Borrar Punto");

		} else {
			botonFoto.setText("Aadir foto");
			boton.setText("Aceptar");
		}

		boton.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View arg0) {

				FrameLayout main = (FrameLayout) findViewById(R.id.formproyecto_view);
				main.removeView(semaforo);
				Button boton = (Button) findViewById(R.id.botonAddPunto);
				if (boton.getText().equals("Aceptar")) {
					pCandidato.setGravedad(semaforo.getColor());

					puntos.add(pCandidato);
					// Aado al XML el punto
					proyecto.addPunto(pCandidato);
					pCandidato = null;

				} else {

					main.removeView(pCandidato.getVista());
					main.removeView(pCandidato.getFotoDibujo());
					boolean borrado = proyecto.eliminarPunto(pCandidato);
					if (borrado) {
						puntos.remove(pCandidato);
						pCandidato = null;
					} else {
						Toast.makeText(context,
								"No se ha podido borrar el punto",
								Toast.LENGTH_LONG).show();
					}

				}
				// Vuelvo a la imagen original
				int res_imagen = context.getResources().getIdentifier(
						"drawable/" + foto, null, context.getPackageName());

				imagenFondo.setImageResource(res_imagen);

				// Dibujo los puntos
				dibujarPuntos();

				cambiarVisibilidadBotones(false);
				permitirPunto = true;

			}
		});

		botonCancelar.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View arg0) {
				// Quitar el punto de la vista
				FrameLayout main = (FrameLayout) findViewById(R.id.formproyecto_view);
				main.removeView(semaforo);

				cambiarVisibilidadBotones(false);
				permitirPunto = true;
				if (!pCandidato.Seleccionado) {
					main.removeView(pCandidato.getVista());
					main.removeView(pCandidato.getFotoDibujo());
					pCandidato = null;
				} else {
				}
				// Vuelvo a la imagen original
				int res_imagen = context.getResources().getIdentifier(
						"drawable/" + foto, null, context.getPackageName());

				imagenFondo.setImageResource(res_imagen);
				dibujarPuntos();
			}

		});

		botonFoto.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View arg0) {
				Button botonFoto = (Button) findViewById(R.id.botonFoto);
				if (botonFoto.getText().equals("Editar Punto")) {

					Intent intent = new Intent(context, FormPunto.class);
					intent.putExtra("Directorio", Directorio);
					intent.putExtra("Nombre", nombreproy);
					// intent.putExtra("DirectorioXML", Directorio + "/" +
					// nombreproy+ ".xml");
					intent.putExtra("puntoX", pCandidato.getX());
					intent.putExtra("puntoY", pCandidato.getY());

					startActivity(intent);
					finish();
				} else {
					final CharSequence[] items = { "De la camara",
							"De la galeria" };

					AlertDialog.Builder builder = new AlertDialog.Builder(
							context);
					builder.setTitle("Aadir foto");
					builder.setSingleChoiceItems(items, -1,
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int item) {

									if (item == 0) {
										Environment
												.getExternalStorageDirectory();
										
										fotoAnadida = formatear(Directorio)
												+ "/"
												+ System.currentTimeMillis()
												+ ".jpg";
										Intent intent = new Intent(
												MediaStore.ACTION_IMAGE_CAPTURE);
										Uri output = Uri.fromFile(new File(
												fotoAnadida));
										intent.putExtra(
												MediaStore.EXTRA_OUTPUT, output);

										startActivityForResult(intent,
												TAKE_PICTURE);

									}
									if (item == 1) {
										Intent intent = new Intent(
												Intent.ACTION_PICK,
												android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
										startActivityForResult(intent,
												SELECT_PICTURE);
									}
									// Toast.makeText(getApplicationContext(),
									// items[item], Toast.LENGTH_SHORT).show();
									dialog.cancel();
								}
							});

					AlertDialog alert = builder.create();
					alert.show();
				}

			}
		});

		// Los botones irn arriba cuando el punto est abajo y viceversa
		FrameLayout.LayoutParams layout1 = new FrameLayout.LayoutParams(
				boton.getLayoutParams());
		FrameLayout.LayoutParams layout2 = new FrameLayout.LayoutParams(
				botonCancelar.getLayoutParams());
		FrameLayout.LayoutParams layout3 = new FrameLayout.LayoutParams(
				botonFoto.getLayoutParams());

		if (punto.getY() < 0.5F) {

			layout1.gravity = Gravity.BOTTOM | Gravity.LEFT;
			layout2.gravity = Gravity.BOTTOM | Gravity.RIGHT;
			layout3.gravity = Gravity.BOTTOM | Gravity.CENTER_HORIZONTAL;

		} else {

			layout1.gravity = Gravity.TOP | Gravity.LEFT;
			layout2.gravity = Gravity.TOP | Gravity.RIGHT;
			layout3.gravity = Gravity.TOP | Gravity.CENTER_HORIZONTAL;
		}

		layout1.width = (int) ancho / 3;
		layout2.width = (int) ancho / 3;
		layout3.width = (int) ancho / 3;

		boton.setLayoutParams(layout1);

		botonCancelar.setLayoutParams(layout2);

		botonFoto.setLayoutParams(layout3);
	}

	private String getRealPathFromURI(Uri contentURI) {
		Cursor cursor = getContentResolver().query(contentURI, null, null,
				null, null);
		cursor.moveToFirst();
		int idx = cursor.getColumnIndex(MediaStore.Images.ImageColumns.DATA);
		return cursor.getString(idx);
	}

	private static boolean borrarCarpeta(File dir) {

		if (dir.isDirectory()) {
			String[] children = dir.list();
			for (int i = 0; i < children.length; i++) {
				boolean success = borrarCarpeta(new File(dir, children[i]));
				if (!success) {
					return false;
				}
			}
		}
		return dir.delete();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.layout.menu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		switch (item.getItemId()) {
		case R.id.borrar:
			AlertDialog alertDialog = new AlertDialog.Builder(this).create();
			alertDialog.setTitle("Borrar Proyecto...");
			alertDialog.setMessage("Est seguro que desea borrar el proyecto?");
			alertDialog.setButton("Si", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					File f = new File(formatear(Directorio));
					if (borrarCarpeta(f)) {
						Intent intent = new Intent(FormProyecto.this,
								FormInicio.class);
						 intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
						startActivity(intent);
						
						finish();
					} else {
						Toast.makeText(context,
								"No se ha podido borrar la carpeta",
								Toast.LENGTH_SHORT).show();
					}

				}
			});

			alertDialog.setIcon(R.drawable.trash);
			alertDialog.show();
			break;

		case R.id.Finalizar:


			finish();
			break;

		case R.id.AddInfo:
			addInfo();
			break;
		}
		return true;
	}

	private String formatear(String nom) {
		String[] cadenas = nom.split(" ");
		String nombreformateado;
		nombreformateado = cadenas[0];

		for (int i = 1; i < cadenas.length; i++) {
			nombreformateado = nombreformateado + "+" + cadenas[i];

		}
		return nombreformateado;
	}

	// Aadir informacion al proyecto
	private void addInfo() {
		final CharSequence[] items = { "Fecha", "Descripcin", "Posicion GPS" };

		AlertDialog.Builder builder = new AlertDialog.Builder(context);
		builder.setTitle("Aadir");
		builder.setSingleChoiceItems(items, -1,
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int item) {
						if (item == 0) {

							String aux = proyecto.getFecha();

							SimpleDateFormat df = new SimpleDateFormat(
									"EEE, d MMM yyyy HH:mm:ss", Locale.ENGLISH);

							java.util.Date d = null;
							try {
								d = df.parse(aux);
							} catch (ParseException e) {
								d = new java.util.Date(Calendar.getInstance()
										.getTimeInMillis());
								e.printStackTrace();
							}
							final Calendar cal = Calendar.getInstance();
							cal.setTime(d);

							DatePickerDialog dialogDate = new DatePickerDialog(
									context, new OnDateSetListener() {

										@Override
										public void onDateSet(DatePicker view,
												int year, int monthOfYear,
												int dayOfMonth) {
											final int[] fechas = { year,
													monthOfYear, dayOfMonth };
											TimePickerDialog.OnTimeSetListener listener = new OnTimeSetListener() {

												@Override
												public void onTimeSet(
														TimePicker view,
														int hourOfDay,
														int minute) {
													java.util.Date d = new java.util.Date(
															fechas[0] - 1900,
															fechas[1],
															fechas[2]);
													d.setHours(hourOfDay);
													d.setMinutes(minute);
													proyecto.setFecha(d);

												}
											};

											TimePickerDialog tpick = new TimePickerDialog(
													context,
													listener,
													cal.get(Calendar.HOUR_OF_DAY),
													cal.get(Calendar.MINUTE),
													true);
											tpick.show();

										}
									}, cal.get(Calendar.YEAR), cal
											.get(Calendar.MONTH), cal
											.get(Calendar.DAY_OF_MONTH));

							dialogDate.show();

						}
						if (item == 1) {
							LayoutInflater li = LayoutInflater.from(context);
							View promptsView = li.inflate(
									R.layout.dialog_descripcion, null);

							AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(
									context);

							alertDialogBuilder.setView(promptsView);

							final EditText userInput = (EditText) promptsView
									.findViewById(R.id.editTextDialogUserInput);

							// Aqui puedo cargar en EditText la descripcion
							// del proyecto si tiene
							userInput.setText(proyecto.getDescripcion());
							alertDialogBuilder
									.setCancelable(false)
									.setPositiveButton(
											"OK",
											new DialogInterface.OnClickListener() {
												public void onClick(
														DialogInterface dialog,
														int id) {

													if (!(userInput.getText()
															.toString().equals(proyecto
															.getDescripcion()))) {
														boolean b = proyecto
																.escribirDescripcion(userInput
																		.getText()
																		.toString());
														Toast t;
														if (b) {
															t = Toast
																	.makeText(
																			context,
																			"Descripcin aadida",
																			Toast.LENGTH_SHORT);

														} else {
															t = Toast
																	.makeText(
																			context,
																			"Error al aadir descripcion",
																			Toast.LENGTH_SHORT);

														}
														t.show();
													}
												}
											})
									.setNegativeButton(
											"Cancel",
											new DialogInterface.OnClickListener() {
												public void onClick(
														DialogInterface dialog,
														int id) {
													dialog.cancel();
												}
											});

							AlertDialog alertDialog = alertDialogBuilder
									.create();

							alertDialog.show();

						}
						if (item == 2) {

							ObtenerPosicion();
						}
						dialog.cancel();

					};
				});

		builder.show();
	}

	// Funciones para el GPS
	private void ObtenerPosicion() {
		mlocManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
		boolean gps_enabled = mlocManager
				.isProviderEnabled(LocationManager.GPS_PROVIDER);

		if (gps_enabled) {
			lanzarGPS();

		}

		else {

			AlertDialog d = new AlertDialog.Builder(FormProyecto.this).create();

			d.setTitle("GPS desactivado");
			d.setMessage("Quiere activar el servicio GPS?");
			d.setButton("Si", new DialogInterface.OnClickListener() {

				public void onClick(DialogInterface dialog, int which) {
					Intent i = new Intent(
							android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS);
					i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK
							| Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED);
					startActivityForResult(i, GPS);
				}
			});
			d.show();
		}
	}

	private void lanzarGPS() {

		mlocListener = new MyLocationListener(this, proyecto);
		mlocManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0,
				mlocListener);

		new Thread() {
			@Override
			public void run() {

				boolean en = false;
				for (int i = 1; i < 18; i++) {

					if ((mlocListener).Encontrada()) {
						en = true;

						mlocManager.removeUpdates(mlocListener);

						break;

					}
					try {
						SystemClock.sleep(500);
					} catch (Exception ex) {

					}
				}
				mlocManager.removeUpdates(mlocListener);
				if (!en) {
					runOnUiThread(new Runnable() {
						public void run() {
							Toast.makeText(FormProyecto.this,
									"No se ha podido encontrar localizacion",
									Toast.LENGTH_LONG).show();
						}
					});

				}
			}

		}.start();

	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {

		if (requestCode == GPS) {
			mlocManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
			boolean gps_enabled = mlocManager
					.isProviderEnabled(LocationManager.GPS_PROVIDER);
			if (gps_enabled) {
				ObtenerPosicion();
			}
		}
		if (requestCode == TAKE_PICTURE) {

			if (resultCode == Activity.RESULT_OK) {
				dibujarFotoDibujo(pCandidato, fotoAnadida);
			}

		}

		if (requestCode == SELECT_PICTURE) {

			try {
				Uri selectedImage = data.getData();

				selectedImage.getPath();
				String imagen = getRealPathFromURI(selectedImage);

				dibujarFotoDibujo(pCandidato, imagen);

			} catch (Exception e) {
			}
		}
	}

}
