package gabriel.proyecto.Forms;

import gabriel.proyecto.R;
import gabriel.proyecto.XmlProyecto;
import gabriel.proyecto.imagenes.Punto;

import java.io.File;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.Toast;

public class FormPunto extends Activity {
	private static int INVISIBLE = 8;
	private static int VISIBLE = 0;
	private static int TAKE_PICTURE = 1;
	private static int SELECT_PICTURE = 2;
	
	/**
	 * @uml.property  name="punto"
	 * @uml.associationEnd  
	 */
	private Punto punto;
	/**
	 * @uml.property  name="directorio"
	 */
	String directorio;
	/**
	 * @uml.property  name="nombreproy"
	 */
	String nombreproy;
	/**
	 * @uml.property  name="proyecto"
	 * @uml.associationEnd  
	 */
	XmlProyecto proyecto;
	/**
	 * @uml.property  name="spinnerGravedad"
	 * @uml.associationEnd  
	 */
	Spinner spinnerGravedad;
	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		super.onCreate(savedInstanceState);
		setContentView(R.layout.form_punto);
		Bundle bundle = getIntent().getExtras();
		directorio=bundle.getString("Directorio");
		nombreproy= bundle.getString("Nombre");
		

		proyecto = new XmlProyecto();
		proyecto.abrirXml(formatear(directorio)+"/"+formatear(nombreproy)+".xml");
		float X=bundle.getFloat("puntoX");
		float Y=bundle.getFloat("puntoY");
		
		System.out.print(X);
		
		punto = proyecto.getPunto(X,Y);
		spinnerGravedad = (Spinner) findViewById(R.id.spinnerGravedad);

		ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(
				this, R.array.Gravedades, android.R.layout.simple_spinner_item);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spinnerGravedad.setAdapter(adapter);
		
		spinnerGravedad.setSelection(punto.getGravedad());

		if (punto.tieneFoto()) {
			File imgFile = new File(punto.getDireccionFoto());
			if (imgFile.exists()) {

				Bitmap myBitmap = BitmapFactory.decodeFile(imgFile
						.getAbsolutePath());

				ImageView myImage = (ImageView) findViewById(R.id.imageVistaPrevia);
				myImage.setImageBitmap(myBitmap);
				Button bCambiar = (Button) findViewById(R.id.botonCambiarFoto);
				bCambiar.setOnClickListener(new OnClickListener() {
					
					@Override
					public void onClick(View v) {
						SacarFoto();
						
					}
				});
			}

		} else {
			
			Button bCambiar = (Button) findViewById(R.id.botonCambiarFoto);
			bCambiar.setVisibility(INVISIBLE);
			ImageView myImage = (ImageView) findViewById(R.id.imageVistaPrevia);
			myImage.setVisibility(INVISIBLE);
			
			Button bAdd=(Button) findViewById(R.id.botonaddFoto);
			bAdd.setVisibility(VISIBLE);
			bAdd.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					SacarFoto();
					
				}
			});
		}
		
		
		Button botGuardar=(Button)findViewById(R.id.botonGuardarPunto);
		botGuardar.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				punto.setGravedad(spinnerGravedad.getSelectedItemPosition());
				boolean b=proyecto.editarPunto(punto);
				if (b){
					finalizar();
				}else{
					
					Toast toast= Toast.makeText(FormPunto.this, "No se han podido guardar los cambios", Toast.LENGTH_SHORT);
					toast.show();
				}
			}
		});
		Button botCancelar=(Button)findViewById(R.id.botonCancelarPunto);
		botCancelar.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				finalizar();
			}
		});
	
	}
	private void finalizar(){
	
		
		Intent intent=new Intent(FormPunto.this,FormProyecto.class);
		intent.putExtra("Directorio", directorio);
		intent.putExtra("Nombre", nombreproy);
		intent.putExtra("Silueta",proyecto.getSilueta());
		startActivity(intent);
		finish();
		
	}
	
	private void SacarFoto(){
		final CharSequence[] items = { "De la camara", "De la galeria" };

		AlertDialog.Builder builder = new AlertDialog.Builder(FormPunto.this);
		builder.setTitle("Aadir foto");
		builder.setSingleChoiceItems(items, -1,
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int item) {

						if (item == 0) {
							Environment.getExternalStorageDirectory();
							
						
							Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
							Uri output;
							if (punto.tieneFoto()){
								output = Uri.fromFile(new File(punto.getDireccionFoto()));
							}else{
								String fotoAnadida = directorio + "/"
										+ System.currentTimeMillis()
										+ ".jpg";
								output=Uri.fromFile(new File(fotoAnadida));
								punto.setDireccionFoto(fotoAnadida);
							}
							
							
							
							intent.putExtra(MediaStore.EXTRA_OUTPUT,
									output);

							startActivityForResult(intent, TAKE_PICTURE);

						}
						if (item == 1) {
							Intent intent = new Intent(
									Intent.ACTION_PICK,
									android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
							startActivityForResult(intent,
									SELECT_PICTURE);
						}
						// Toast.makeText(getApplicationContext(),
						// items[item], Toast.LENGTH_SHORT).show();
						dialog.cancel();
					}
				});

		AlertDialog alert = builder.create();
		alert.show();
	}


	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		
	
		punto.setTieneFoto(true);
		
		if (requestCode == TAKE_PICTURE) {}


		if (requestCode == SELECT_PICTURE) {

			try {
				
				Uri selectedImage = data.getData();

				selectedImage.getPath();
				String imagen = getRealPathFromURI(selectedImage);
				punto.setDireccionFoto(imagen);
				//dibujarFotoDibujo(pCandidato, imagen);


			} catch (Exception e) {
			}
		}

		File imgFile = new File(punto.getDireccionFoto());
		if (imgFile.exists()) {

		Bitmap myBitmap = BitmapFactory.decodeFile(imgFile.getAbsolutePath());

		ImageView myImage = (ImageView) findViewById(R.id.imageVistaPrevia);
		myImage.setImageBitmap(myBitmap);
		myImage.setVisibility(VISIBLE);
		Button bA,bC;
		bA=(Button) findViewById(R.id.botonaddFoto);
		bC=(Button) findViewById(R.id.botonCambiarFoto);
		bA.setVisibility(INVISIBLE);
		bC.setVisibility(VISIBLE);
		
		}
		
	}
	
	private String getRealPathFromURI(Uri contentURI) {
		Cursor cursor = getContentResolver().query(contentURI, null, null,
				null, null);
		cursor.moveToFirst();
		int idx = cursor.getColumnIndex(MediaStore.Images.ImageColumns.DATA);
		return cursor.getString(idx);
	}
	
	private String formatear(String nom) {
		String[] cadenas = nom.split(" ");
		String nombreformateado;
		nombreformateado = cadenas[0];

		for (int i = 1; i < cadenas.length; i++) {
			nombreformateado = nombreformateado + "+" + cadenas[i];

		}
		return nombreformateado;
	}
}
