package gabriel.proyecto.imagenes;

import gabriel.proyecto.R;
import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;

public class FotoDibujo extends View{
	 /**
	 * @uml.property  name="x"
	 */
	private final float x;
	 /**
	 * @uml.property  name="y"
	 */
	private final float y;
	 /**
	 * @uml.property  name="xR"
	 */
	private final float xR;
	/**
	 * @uml.property  name="yR"
	 */
	private final float yR;
	 
	 /**
	 * @uml.property  name="bmap"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	private  Bitmap bmap;
	 /**
	 * @uml.property  name="foto"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	private ImageView foto;
	 /**
	 * @uml.property  name="paint"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	private Paint paint;
	 /**
	 * @uml.property  name="reducido"
	 */
	private boolean reducido;
	 /**
	 * @uml.property  name="context"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	private Context context;
	 /**
	 * @uml.property  name="dialog"
	 * @uml.associationEnd  
	 */
	private Dialog dialog;
	
	
	 
  public FotoDibujo(Context context, float x, float y,ImageView foto) {
      
	  super(context);
      this.context=context;
    
     this.foto=foto;

      this.x = x;
      this.y = y;
     
      this.xR=x+80;
      this.yR=y+25;
      
      bmap = BitmapFactory.decodeResource(getResources(), R.drawable.photo);
     
      paint=new Paint();
	  paint.setAlpha(240);
	  reducido=false;
	  dialog=null;
  
  }
  
  
  @Override
  protected void onDraw(Canvas canvas) {

	  
	  super.onDraw(canvas);
	  float auxX;
	  float auxY;
	  if (reducido){
		  auxX=this.xR;
		  auxY=this.yR;
	  }
	  else{
		  auxX=this.x;
		  auxY=this.y;
		  }
	  
	   canvas.drawBitmap(bmap, auxX , auxY, paint);
     
      
  }
  public boolean Reducido(){return reducido;}
  
  public void reducir(){
	
	  
	  Bitmap aux=Bitmap.createScaledBitmap(bmap, (int)(this.bmap.getWidth()/1.75), (int)(this.bmap.getHeight()/1.75),false);
	  this.bmap=aux;
	  paint.setAlpha(120);
	  reducido=true;
	  
	  invalidate();
  }
  
  public void ampliar(){
	  
	  Bitmap aux=Bitmap.createScaledBitmap(bmap, (int)(this.bmap.getWidth()*1.75),(int) (this.bmap.getHeight()*1.75),false);
	  this.bmap=aux;
	  paint.setAlpha(240);
	  reducido=false;
	  invalidate();
	  
  }
  
  public void setImageView(ImageView i){this.foto=i;}
  public ImageView getImageView(){return this.foto;}
  
  @Override
  public boolean onTouchEvent(MotionEvent event)
  {
	  if (!reducido){
		  
	   Rect rectangulo=new Rect();
	   rectangulo.set((int)this.x, (int)this.y, (int)(this.x + bmap.getWidth()),(int)(this.y + bmap.getHeight()));
	   if (rectangulo.contains((int)(event.getX()),(int)(event.getY()))){
		   {
			   Activity a=(Activity)context;
			  
			   if (dialog==null){
			   
			   dialog = new Dialog(a,R.style.dialog_theme);
			   dialog.setCanceledOnTouchOutside(true);
			   dialog.setContentView(foto);

			   }
			   dialog.show();

		   }
		   
	   }
	  }
	  return false;
  }
  
 

}
