package gabriel.proyecto.imagenes;

import android.content.Context;
import android.view.View;

public class Punto {
	/**
	 * @uml.property  name="x"
	 */
	 private float X;
	/** 
	 * @uml.property name="y"
	 */
	 private float Y;

	/**
	 * @uml.property  name="zonaVehiculo"
	 */
	private int ZonaVehiculo;
	/**
	 * @uml.property  name="vista"
	 * @uml.associationEnd  
	 */
	private View vista;
	/**
	 * @uml.property  name="gravedad"
	 */
	private int Gravedad;
	/**
	 * @uml.property  name="seleccionado"
	 */
	public boolean Seleccionado;

	/**
	 * @uml.property  name="context"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	private Context context;

	/**
	 * @uml.property  name="direccionFoto"
	 */
	private String direccionFoto;
	/**
	 * @uml.property  name="fotoD"
	 * @uml.associationEnd  
	 */
	private FotoDibujo fotoD;
	/**
	 * @uml.property  name="tieneFoto"
	 */
	private boolean tieneFoto;

	public Punto(Context context, float x, float y, int anchura, int altura) {
		this.context = context;
		this.X = x / anchura;
		this.Y = y / altura;
		this.Gravedad = 0;
		this.Seleccionado = false;
		tieneFoto = false;
		this.fotoD = null;
		direccionFoto = null;
	}

	/**
	 * @param Direccion
	 * @uml.property  name="direccionFoto"
	 */
	public void setDireccionFoto(String Direccion) {
		this.direccionFoto = Direccion;
	}

	/**
	 * @return
	 * @uml.property  name="direccionFoto"
	 */
	public String getDireccionFoto() {
		return this.direccionFoto;
	}

	public Punto(Context context, float x, float y, int gravedad,
			int zonaVehiculo, boolean tieneFoto) {

		this.context = context;
		this.X = x;
		this.Y = y;
		this.Gravedad = gravedad;
		this.ZonaVehiculo = zonaVehiculo;

		
		this.tieneFoto = tieneFoto;
		this.fotoD = null;

		this.Seleccionado = false;
	}

	public void setZona(int zona) {

		ZonaVehiculo = zona;
	}

	public void setFotoDibujo(FotoDibujo fd) {
		this.fotoD = fd;
	}

	public FotoDibujo getFotoDibujo() {
		return this.fotoD;
	}

	public boolean tieneFoto() {

		return tieneFoto;
	}

	/**
	 * @param b
	 * @uml.property  name="tieneFoto"
	 */
	public void setTieneFoto(boolean b) {
		this.tieneFoto = b;
	}

	public boolean equals(Punto p2) {

		if (esCercano(this.X, p2.X, 0.09F)) {
			if (esCercano(this.Y, p2.Y, 0.07F)) {
				return true;
			}

		}
		return false;
	}

	private boolean esCercano(float x1, float x2, float cercania) {

		float dif;
		dif = Math.abs(x1 - x2);
		return (dif < cercania);

	}

	/**
	 * @return
	 * @uml.property  name="x"
	 */
	public float getX() {
		return this.X;
	}

	/** 
	 * @return
	 * @uml.property  name="y"
	 */
	public float getY() {
		return Y;
	}

	public int getZona() {
		return this.ZonaVehiculo;
	}

	/**
	 * @param v
	 * @uml.property  name="vista"
	 */
	public void setVista(View v) {
		this.vista = v;
	}

	/**
	 * @return
	 * @uml.property  name="vista"
	 */
	public View getVista() {
		return this.vista;
	}

	/**
	 * @return
	 * @uml.property  name="gravedad"
	 */
	public int getGravedad() {
		return this.Gravedad;
	}

	/**
	 * @param gravedad
	 * @uml.property  name="gravedad"
	 */
	public void setGravedad(int gravedad) {
		this.Gravedad = gravedad;
	}

	public boolean verZona(String foto) {

		// Leo de los recursos (string.xml) los correspondientes a la foto
		int resource_Array = context.getResources().getIdentifier(foto,
				"array", context.getPackageName());

		String[] zonas = context.getResources().getStringArray(resource_Array);

		float limiteiz = Float.parseFloat(zonas[0]);
		float limitedch = Float.parseFloat(zonas[1]);

		float mitad = Float.parseFloat(zonas[2]);

		float pilotocopi = Float.parseFloat(zonas[3]);
		String centro = zonas[6];

		if ((this.X > limiteiz) && (this.X < limitedch)) {

			// Parte superior
			if (this.Y < mitad) {
				if (this.X <= pilotocopi) {
					// ZONA PILOTO: 0
					// toast= Toast.makeText(context,"Zona Piloto",4);
					this.ZonaVehiculo = 0;

					// int puntosinescalar=(int)punto.xSinEscalar;

				} else {
					// ZONA COPILOTO: 1
					// toast= Toast.makeText(context,"Zona copiloto",4);
					this.ZonaVehiculo = 1;
				}

			}
			// Parte abajo
			else {
				if (centro.equals("SI")) {
					if (this.X < Float.parseFloat(zonas[4])) {
						// ASIENTO IZQUIERDO: 2
						// toast= Toast.makeText(context,"Asiento izquierdo",4);
						this.ZonaVehiculo = 2;
					} else if (this.X > Float.parseFloat(zonas[5])) {
						// ASIENTO DERECHO: 3
						this.ZonaVehiculo = 3;
						// toast= Toast.makeText(context,"Asiento derecho",4);

					} else {
						// ASIENTO CENTRAL: 4
						// toast= Toast.makeText(context,"Asiento central",4);
						this.ZonaVehiculo = 4;
					}
				} else {

					if (this.X < Float.parseFloat(zonas[4])) {
						// ASIENTO IZQUIERDO: 2
						// toast= Toast.makeText(context,"Asiento izquierdo",4);
						this.ZonaVehiculo = 2;
					} else {
						// ASIENTO DERECHO: 3
						// toast= Toast.makeText(context,"Asiento derecho",4);
						this.ZonaVehiculo = 3;
					}

				}

			}
			// toast.show();
			return true;
		} else {

			return false;
		}
	}

	/**
	 * Setter of the property <tt>y</tt>
	 * @param y  The Y to set.
	 * @uml.property  name="y"
	 */
	public void setY(float y) {
		Y = y;
	}

}