package gabriel.proyecto.imagenes;


import gabriel.proyecto.R;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Rect;
import android.view.MotionEvent;
import android.view.View;

public class Semaforo extends View{
	 /**
	 * @uml.property  name="x"
	 */
	private final float x;
	 /**
	 * @uml.property  name="y"
	 */
	private final float y;
	 /**
	 * @uml.property  name="bmap"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	private  Bitmap bmap;
	 /**
	 * @uml.property  name="color"
	 */
	private int color;
	
	
	 
   public Semaforo(Context context, float x, float y) {
       super(context);
   
       this.x = x;
       this.y = y;
      
       bmap = BitmapFactory.decodeResource(getResources(), R.drawable.semaforo);
       this.color=0;
      
   
   }
   @Override
   protected void onDraw(Canvas canvas) {
	   super.onDraw(canvas);

	   canvas.drawBitmap(bmap, this.x , this.y, null);
       
       
   }
   
   /**
 * @return
 * @uml.property  name="x"
 */
public float getX(){
	   return this.x;
	   
   }
   /**
 * @return
 * @uml.property  name="y"
 */
public float getY(){
	   return this.y;
   }
   
   /**
 * @return
 * @uml.property  name="color"
 */
public int getColor(){
	   return this.color;
   }
   
   @Override
   public boolean onTouchEvent(MotionEvent event)
   {
	   
	   Rect rectangulo=new Rect();
	   rectangulo.set((int)this.x, (int)this.y, (int)(this.x + bmap.getWidth()),(int)(this.y + bmap.getHeight()));
	 
	   
	   
	   if (rectangulo.contains((int)event.getX(), (int)event.getY())){
		   
		   Rect rectRojo=new Rect(rectangulo.left,rectangulo.top,rectangulo.right,rectangulo.bottom-2*(rectangulo.height()/3));
		   Rect rectAmbarRojo=new Rect(rectangulo.left,rectangulo.top,rectangulo.right,rectangulo.bottom-1*(rectangulo.height()/3));
		   
		   if (rectRojo.contains((int)event.getX(), (int)event.getY())){
			   if (color==1){
				   bmap=BitmapFactory.decodeResource(getResources(), R.drawable.semaforo);
				   this.color=0;
			   }else{
				   bmap=BitmapFactory.decodeResource(getResources(), R.drawable.semaforo_rojo);
				   this.color=1;
			   }

			   
			   
		   }else if(rectAmbarRojo.contains((int)event.getX(), (int)event.getY())){
			   
			   if (color==2){
				   bmap=BitmapFactory.decodeResource(getResources(), R.drawable.semaforo);
				   this.color=0;
			   }else{
				   bmap=BitmapFactory.decodeResource(getResources(), R.drawable.semaforo_ambar);
				   this.color=2;
			   }
		   }
		   else{
			   if (color==3){
				   bmap=BitmapFactory.decodeResource(getResources(), R.drawable.semaforo);
				   this.color=0;
			   }else{
				   bmap=BitmapFactory.decodeResource(getResources(), R.drawable.semaforo_verde);
				   this.color=3;
			   }
			   
		   }
		   
		  
		   invalidate();
   
	   }
	   //devuelvo false, asi el evento touch no se considera atendido y lo atiende la vista padre
	   return false;
   }
   

}